stages:
  - 🦄tests

variables:
  GITLAB_URL: http://www.gitlab.com

📞remote:
  only:
    - master
  when: manual
  stage: 🦄tests
  #tags:
  #  - simple-runner
  script:
    # trigger_remote_job <project_name> <message>
    - trigger_remote_job "bots-garden/sandbox/simple-pong" "👋 Hello 🌍"

# Shell helpers
.tools: &tools |

    function rawurlencode() {
        local string="${1}"
        local strlen=${#string}
        local encoded=""
        local pos c o

        for (( pos=0 ; pos<strlen ; pos++ )); do
          c=${string:$pos:1}
          case "$c" in
              [-_.~a-zA-Z0-9] ) o="${c}" ;;
              * ) printf -v o '%%%02x' "'$c"
          esac
          encoded+="${o}"
        done
        echo "${encoded}"
    }

    function trigger_remote_job() {
        export PROJECT=$( rawurlencode "$1" ) # REMOTE_PROJECT_NAME
        export TRIGGER_URL="$GITLAB_URL/api/v4/projects/$PROJECT/trigger/pipeline"
        echo "$TRIGGER_URL"
        curl -X POST -F token=$CI_JOB_TOKEN \
        -F ref="master" \
        -F variables[REMOTE_MESSAGE]="$2" \
        -F variables[REMOTE_FROM]="$CI_PROJECT_NAME" \
        $TRIGGER_URL 
    }

before_script:
  - *tools
